Parcours_d2rq

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.wscreation.findpath
Class Parcours_d2rq

    java.lang.Object
      com.wscreation.findpath.Parcours_d2rq

    public class Parcours_d2rq

extends java.lang.Object

all methods needed to parse a d2rq mapping file

Author:
  WOLLBRETT

Field Summary
`private java.util.Vector<AssociationWithoutAttributs>` | `assWithoutAttributs`
`private static java.lang.Boolean` | `DEBUG`
`private java.util.Map<java.lang.String,java.lang.String>` | `foreignKeys`
`private java.lang.String` | `mappingPath`
`private com.hp.hpl.jena.rdf.model.Model` | `model`
`private com.hp.hpl.jena.rdf.model.Model` | `modelToParse`
`private java.util.Map<java.lang.String,java.lang.String>` | `namespaces`
`private java.util.Vector<Table>` | `tables`

Constructor Summary
`Parcours_d2rq(com.hp.hpl.jena.rdf.model.Model model)`
`Parcours_d2rq(com.hp.hpl.jena.rdf.model.Model model, boolean preparcours)`
`Parcours_d2rq(java.lang.String mappingPath)`
`Parcours_d2rq(java.lang.String mappingPath, boolean preparcours)`

Method Summary
`private void` | `associationTables()` modifie les statements associés à un table d'association.
`java.util.Vector<com.hp.hpl.jena.rdf.model.Statement>` | `chooseAColumn(java.util.Vector<com.hp.hpl.jena.rdf.model.Statement> column)` si plusieurs colonnes d'une base de données sont annotées avec le même concept il est possible de choisir la colonne souhaitée
`com.hp.hpl.jena.rdf.model.Resource` | `columnIsInTable(com.hp.hpl.jena.rdf.model.Resource column)`
`java.util.Vector<com.hp.hpl.jena.rdf.model.Resource>` | `findChildren(com.hp.hpl.jena.rdf.model.Resource parentOfHeritage)` retrieve childrens of a selected table
`int` | `getArity(com.hp.hpl.jena.rdf.model.Resource table)`
`java.util.Vector<AssociationWithoutAttributs>` | `getAssociationWithoutAttributs()`
`java.util.Map<java.lang.String,java.lang.String>` | `getForeignKeys()`
`com.hp.hpl.jena.rdf.model.Model` | `getModel()`
`com.hp.hpl.jena.rdf.model.Model` | `getModelToParse()`
`java.util.Map<java.lang.String,java.lang.String>` | `getNamespaces()`
`private void` | `getNamespaces(com.hp.hpl.jena.rdf.model.Model m)` retrieve namespaces of the mapping file
`com.hp.hpl.jena.rdf.model.Resource` | `getTableResource(java.util.Vector<com.hp.hpl.jena.rdf.model.Statement> vect)`
`java.util.Vector<Table>` | `getTables()`
`boolean` | `hasForeignKeys(java.util.Vector<com.hp.hpl.jena.rdf.model.Statement> columnStatements)`
`java.util.Vector<com.hp.hpl.jena.rdf.model.Statement>` | `infosSurUneColonne(com.hp.hpl.jena.rdf.model.Resource colonne)` permet de recupérer toutes les iformtations sur une colonne.
`java.util.Vector<com.hp.hpl.jena.rdf.model.Statement>` | `infosSurUneTable(com.hp.hpl.jena.rdf.model.Resource table)`
`com.hp.hpl.jena.rdf.model.Resource` | `inWhichTableIsTheColumn(com.hp.hpl.jena.rdf.model.Resource res)`
`private void` | `listAssociationWithoutAttributs()` récupère les informations sur les tables d'associations sans attributs.
`private void` | `listForeignKeys()` liste de toutes les clés étrangères.
`private void` | `listTables()` create a vector containing all tables of the mapping file
`int` | `numberOfColumnWithThisAnnotation(com.hp.hpl.jena.rdf.model.Resource annotation)` renvoie le nombre de colonnes qui possèdent l'annotation sélectionnée
`private void` | `preparcours()` premier parcours du graphe avant de chercher un chemin.
`private void` | `readModel()`
`com.hp.hpl.jena.rdf.model.Resource` | `refersToDatabase(com.hp.hpl.jena.rdf.model.Resource table)` detect database containing the table
`java.util.Vector<com.hp.hpl.jena.rdf.model.Statement>` | `retrieveColumnWithThisAnnotation(com.hp.hpl.jena.rdf.model.Resource annotation)` renvoie les statement de la colonne annotée avec le concept sélectionné
`java.util.Vector<com.hp.hpl.jena.rdf.model.Statement>` | `whereIsTheAnotation(com.hp.hpl.jena.rdf.model.Resource concept)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DEBUG

    private static java.lang.Boolean DEBUG

### mappingPath

    private java.lang.String mappingPath

### modelToParse

    private com.hp.hpl.jena.rdf.model.Model modelToParse

### namespaces

    private java.util.Map<java.lang.String,java.lang.String> namespaces

### foreignKeys

    private java.util.Map<java.lang.String,java.lang.String> foreignKeys

### tables

    private java.util.Vector<Table> tables

### assWithoutAttributs

    private java.util.Vector<AssociationWithoutAttributs> assWithoutAttributs

### model

    private com.hp.hpl.jena.rdf.model.Model model

Constructor Detail

### Parcours_d2rq

    public Parcours_d2rq(com.hp.hpl.jena.rdf.model.Model model)

### Parcours_d2rq

    public Parcours_d2rq(java.lang.String mappingPath)

Parameters:
  `mappingPath` -

### Parcours_d2rq

    public Parcours_d2rq(com.hp.hpl.jena.rdf.model.Model model,
                         boolean preparcours)

Parameters:
  `model` -
  `preparcours` -

### Parcours_d2rq

    public Parcours_d2rq(java.lang.String mappingPath,
                         boolean preparcours)

Parameters:
  `mappingPath` -
  `preparcours` -

Method Detail

### getModelToParse

    public com.hp.hpl.jena.rdf.model.Model getModelToParse()

### getAssociationWithoutAttributs

    public java.util.Vector<AssociationWithoutAttributs> getAssociationWithoutAttributs()

### getModel

    public com.hp.hpl.jena.rdf.model.Model getModel()

### getNamespaces

    public java.util.Map<java.lang.String,java.lang.String> getNamespaces()

### getForeignKeys

    public java.util.Map<java.lang.String,java.lang.String> getForeignKeys()

### getTables

    public java.util.Vector<Table> getTables()

### readModel

    private void readModel()

### preparcours

    private void preparcours()

  premier parcours du graphe avant de chercher un chemin. Ce parcours permet de supprimer les predicats non utilisés dans la recherche de chemin. A la fin de ce parcours il ne reste que des prédicats utiles pour rechercher un chemin dans le graphe Ces prédicats sont les suivants: join: clé étrangère URIpattern: clé(s) primaire(s) d'une table dataStorage: BD dans laquelle est contenue la table refersToClassMap: table dans laquelle est contenue la colonne (clé primaire?) belongToClassMap: table dans laquelle est contenue la colonne

### getNamespaces

    private void getNamespaces(com.hp.hpl.jena.rdf.model.Model m)

  retrieve namespaces of the mapping file

  Parameters:
    `m` - Model

### listTables

    private void listTables()

  create a vector containing all tables of the mapping file

### listForeignKeys

    private void listForeignKeys()

  liste de toutes les clés étrangères. Cette liste est nécessaire pour trouver les tables ayant une clé étrangère vers la table en cours de traitement. les statements ayant le predicat join permettent de trouver les clés étrangères dans le sens clé étrangère vers table d'origine (key ver value pour la map). Cette liste est nécessaire pour parcourir les clés étrangères dans le sens table d'origine vers la clé étrangère (value vers key pour la map)

### associationTables

    private void associationTables()

  modifie les statements associés à un table d'association. Simule la création d'un objet ClassMap pour chaque table d'association. Permet de prendre en compte les tables d'association

### hasForeignKeys

    public boolean hasForeignKeys(java.util.Vector<com.hp.hpl.jena.rdf.model.Statement> columnStatements)

### infosSurUneTable

    public java.util.Vector<com.hp.hpl.jena.rdf.model.Statement> infosSurUneTable(com.hp.hpl.jena.rdf.model.Resource table)

### columnIsInTable

    public com.hp.hpl.jena.rdf.model.Resource columnIsInTable(com.hp.hpl.jena.rdf.model.Resource column)

### getTableResource

    public com.hp.hpl.jena.rdf.model.Resource getTableResource(java.util.Vector<com.hp.hpl.jena.rdf.model.Statement> vect)

### inWhichTableIsTheColumn

    public com.hp.hpl.jena.rdf.model.Resource inWhichTableIsTheColumn(com.hp.hpl.jena.rdf.model.Resource res)

### numberOfColumnWithThisAnnotation

    public int numberOfColumnWithThisAnnotation(com.hp.hpl.jena.rdf.model.Resource annotation)

  renvoie le nombre de colonnes qui possèdent l'annotation sélectionnée

  Parameters:
    `annotation` -
  Returns:

### whereIsTheAnotation

    public java.util.Vector<com.hp.hpl.jena.rdf.model.Statement> whereIsTheAnotation(com.hp.hpl.jena.rdf.model.Resource concept)

### retrieveColumnWithThisAnnotation

    public java.util.Vector<com.hp.hpl.jena.rdf.model.Statement> retrieveColumnWithThisAnnotation(com.hp.hpl.jena.rdf.model.Resource annotation)

  renvoie les statement de la colonne annotée avec le concept sélectionné

  Parameters:
    `annotation` -
  Returns:

### chooseAColumn

    public java.util.Vector<com.hp.hpl.jena.rdf.model.Statement> chooseAColumn(java.util.Vector<com.hp.hpl.jena.rdf.model.Statement> column)

  si plusieurs colonnes d'une base de données sont annotées avec le même concept il est possible de choisir la colonne souhaitée

  Parameters:
    `column` -
  Returns:

### infosSurUneColonne

    public java.util.Vector<com.hp.hpl.jena.rdf.model.Statement> infosSurUneColonne(com.hp.hpl.jena.rdf.model.Resource colonne)

  permet de recupérer toutes les iformtations sur une colonne. Ces informations sont l'annotation associée, la table dans laquelle elle est contenue et les clés étrangères dont elle dépend

  Parameters:
    `colonne` -
  Returns:
    Vector

### refersToDatabase

    public com.hp.hpl.jena.rdf.model.Resource refersToDatabase(com.hp.hpl.jena.rdf.model.Resource table)

  detect database containing the table

  Parameters:
    `table` -
  Returns:

### getArity

    public int getArity(com.hp.hpl.jena.rdf.model.Resource table)

### findChildren

    public java.util.Vector<com.hp.hpl.jena.rdf.model.Resource> findChildren(com.hp.hpl.jena.rdf.model.Resource parentOfHeritage)

  retrieve childrens of a selected table

  Parameters:
    `parentOfHeritage` -
  Returns:

### listAssociationWithoutAttributs

    private void listAssociationWithoutAttributs()

  récupère les informations sur les tables d'associations sans attributs. Ces tables sont repérées en utilisant le fait qu'elles soient considérées comme des propriétés et non des classes dans le fichier de mapping.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD